<?php

use \Whmcs\Database\Capsule;


require_once(dirname(__FILE__) . DS . "../../classes" . DS . "class.Product.php");
require_once(dirname(__FILE__) . DS . "../../classes" . DS . "class.MG_NodePing_Product.php");
require_once(dirname(__FILE__) . DS . "../../classes" . DS . "class.WHMCS_Product.php");
require_once(dirname(__FILE__) . DS . "../../classes" . DS . "class.NodePing.php");
require_once(dirname(__FILE__) . DS . "../../classes" . DS . "class.NodePing_Curl.php");
require_once(dirname(__FILE__) . DS . "../../classes" . DS . "class.NodePing_Helpers.php");


// Initialize table schema

if (!Capsule::schema()->hasTable('nodeping_resourcemonitors')) {
    Capsule::schema()->create(
        'nodeping_resourcemonitors',
            function ($table) {
                /** @var \Illuminate\Database\Schema\Blueprint $table */
                $table->increments('id');
                $table->string('checkid');
        }
   );
}



if( !class_exists( "Tresourcemonitor" ) ){
    class Tresourcemonitor{

        public static $params = [
            "dependency" => "",
            "contacts" => [
             ],
         ];

        public static function getChecks(){
            return Capsule::table('nodeping_resourcemonitors')->get();
        }


        public static function getModuleSettings(){
            $server = \WHMCS\Database\Capsule::table('tblservers')->where('type','nodePing')->first();
            $nodePing = new \NodePing($server->accesshash);
            $checks = $nodePing->getChecks();
            $options = [];
            foreach( $checks as $check){
                if( $check->type == 'PUSH' ){
                    $options[$check->_id] = $check->label;
                }
            }
            return [ [ 'name' => 'RESOURCEMONITORTEMPLATE','title' => 'Resource Monitor Template', 'type' => 'select', 'values' => $options ] ];
        }

        public static function afterChangePackage($params){
            return;

        }

        public static function afterCreateCheck($params,$checkId){
            if( isset($_POST['resourcemonitor']) ){
                Capsule::table('nodeping_resourcemonitors')->insert(
                    [
                        'checkid' => $checkId
                    ]
                );
                header('Location: modules/servers/nodePing/templates/resourcemonitor.php');
                die();
            }
            return;
        }

        public static function afterDeleteCheck($params,$checkId){
            Capsule::table('nodeping_resourcemonitors')->where('checkid',$checkId)->delete();
            return;
        }

        public function afterEditCheck($params,$POST,$data,$API){
            return $POST;
        }

        public static function filterContactList($contacts){
            return $contacts;
        }

    }
}

// HTML
$plugins["tresourcemonitor"]["checks"]["html"] = "
";
// Extra POST PARAMS

$plugins["tresourcemonitor"]["params"] = [
    "dependency" => "",
    "contacts" => [ 
    ],
    "extra_checks" => [
        [
            'title' => 'Resource Monitor',
            'type' => 'checkbox'
        ]
    ]
];

// Module settings
$plugins["tresourcemonitor"]["module_settings"] = true;

$plugins["tresourcemonitor"]['htmlfilter'] = [
    [ 'value' => 'Resource', 'text' =>  'Resource Monitors'],
    [ 'value' => 'Uptime', 'text' =>  'Uptime Monitors']
];
